(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
 Demonstration du tracs de points, lignes, rectangles (vide puis plein),   
 cercles et disques avec les units EcranVGA, ModeX, Vesa2.                 
                                                                            
 (Passez d'une unit  l'autre en changeant les '$DEFINE')                  
*)

{$M 4096,0,0}

{===> Option vido : choix entre mode 13h (par dfaut) / ModeX / VESA }
{$DEFINE Vesa: Utilise VESA                                                 }
{$IFNDEF Vesa}
  {-$DEFINE ModeX: Utilise le mode X 320x200x8 sur 4 pages                   }
{$ENDIF}

{-$DEFINE Fps: Affiche le nombre de pixel, ligne, ... / seconde              }

{$DEFINE SyncroEcran: Se syncronise avec l'cran (vite le syntillement)    }
{ Remarque : pour le trac des disques et rectangles il est instaur d'office}

uses
  Clavier,
  {$IFDEF Fps}FPS,{$ENDIF}
  {$IFDEF Vesa}Vesa2{$ELSE}{$IFDEF ModeX}ModeX{$ELSE}EcranVGA{$ENDIF}{$ENDIF};

const
{$IFDEF Vesa}
  LargEcran = 800;
  HautEcran = 600;
{$ELSE}
  LargEcran = 320;
  HautEcran = 200;
{$ENDIF}
  CoulFond = 1;

begin
  { Lance le mode graphique 320x200 pixels en 256 couleurs }
  {$IFDEF Vesa}LanceMode (LargEcran,HautEcran,8){$ELSE}{$IFDEF ModeX}LanceModeX{$ELSE}ModeVga256{$ENDIF}{$ENDIF};
  {$IFDEF Vesa}EffaceEcranVesa{$ELSE}{$IFDEF ModeX}EffaceEcranX{$ELSE}EffaceEcran{$ENDIF}{$ENDIF} (CoulFond);
  {$IFDEF Fps}InitFps (-1,-1,FALSE);{$ENDIF}
  Randomize;

  {=== Dessin de points ===}
  repeat
    {$IFDEF Vesa}DessinePoint8{$ELSE}{$IFDEF ModeX}DessinePointX{$ELSE}DessinePoint{$ENDIF}{$ENDIF}
      (Random(LargEcran*2)-LargEcran shr 1,
       Random(HautEcran*2)-HautEcran shr 1,
       Random(256));

   {$IFDEF Fps}ActuFps;{$ENDIF}
  until TouchPresse;
  LitTouche; {$IFDEF Vesa}EffaceEcranVesa{$ELSE}{$IFDEF ModeX}EffaceEcranX{$ELSE}EffaceEcran{$ENDIF}{$ENDIF} (CoulFond);
  {$IFDEF Fps}
    FpsInfo.TxtModifie := TRUE; ActuFps;
    LitTouche; ReinitFps;
  {$ENDIF}

  {=== Dessin de lignes ===}
  repeat
    {$IFDEF SyncroEcran}AttendEcran;{$ENDIF}
    {$IFDEF Vesa}DessineLigne8{$ELSE}{$IFDEF ModeX}DessineLigneX{$ELSE}DessineLigne{$ENDIF}{$ENDIF}
      (Random(LargEcran*2)-LargEcran shr 1,Random(HautEcran*2)-HautEcran shr 1,
       Random(LargEcran*2)-LargEcran shr 1,Random(HautEcran*2)-HautEcran shr 1,
       Random(256));

   {$IFDEF Fps}ActuFps;{$ENDIF}
  until TouchPresse;
  LitTouche; {$IFDEF Vesa}EffaceEcranVesa{$ELSE}{$IFDEF ModeX}EffaceEcranX{$ELSE}EffaceEcran{$ENDIF}{$ENDIF} (CoulFond);
  {$IFDEF Fps}
    FpsInfo.TxtModifie := TRUE; ActuFps;
    LitTouche; ReinitFps;
  {$ENDIF}

  {=== Dessin de cercles ===}
  repeat
    {$IFDEF SyncroEcran}AttendEcran;{$ENDIF}
    {$IFDEF Vesa}DessineCercle8{$ELSE}{$IFDEF ModeX}DessineCercleX{$ELSE}DessineCercle{$ENDIF}{$ENDIF}
      (Random(LargEcran*2)-LargEcran shr 1,Random(HautEcran*2)-HautEcran shr 1,
       Random(HautEcran shr 1),Random(256));

   {$IFDEF Fps}ActuFps;{$ENDIF}
  until TouchPresse;
  LitTouche; {$IFDEF Vesa}EffaceEcranVesa{$ELSE}{$IFDEF ModeX}EffaceEcranX{$ELSE}EffaceEcran{$ENDIF}{$ENDIF} (CoulFond);
  {$IFDEF Fps}
    FpsInfo.TxtModifie := TRUE; ActuFps;
    LitTouche; ReinitFps;
  {$ENDIF}

  {=== Dessin de disques ===}
  repeat
    {$IFDEF SyncroEcran}AttendEcran;{$ENDIF}
    {$IFDEF Vesa}DessineDisque8{$ELSE}{$IFDEF ModeX}DessineDisqueX{$ELSE}DessineDisque{$ENDIF}{$ENDIF}
      (Random(LargEcran*2)-LargEcran shr 1,Random(HautEcran*2)-HautEcran shr 1,
       Random(HautEcran shr 1),Random(256));

   {$IFDEF Fps}ActuFps;{$ENDIF}
  until TouchPresse;
  LitTouche; {$IFDEF Vesa}EffaceEcranVesa{$ELSE}{$IFDEF ModeX}EffaceEcranX{$ELSE}EffaceEcran{$ENDIF}{$ENDIF} (CoulFond);
  {$IFDEF Fps}
    FpsInfo.TxtModifie := TRUE; ActuFps;
    LitTouche; ReinitFps;
  {$ENDIF}

  {=== Dessin de rectangles ===}
  repeat
    {$IFDEF SyncroEcran}AttendEcran;{$ENDIF}
    {$IFDEF Vesa}DessineRectangle8{$ELSE}{$IFDEF ModeX}DessineRectangleX{$ELSE}DessineRectangle{$ENDIF}{$ENDIF}
      (Random(LargEcran*2)-LargEcran shr 1,
       Random(HautEcran*2)-HautEcran shr 1,
       Random(LargEcran shr 1),
       Random(HautEcran shr 1),
       Random(256));

   {$IFDEF Fps}ActuFps;{$ENDIF}
  until TouchPresse;
  LitTouche; {$IFDEF Vesa}EffaceEcranVesa{$ELSE}{$IFDEF ModeX}EffaceEcranX{$ELSE}EffaceEcran{$ENDIF}{$ENDIF} (CoulFond);
  {$IFDEF Fps}
    FpsInfo.TxtModifie := TRUE; ActuFps;
    LitTouche; ReinitFps;
  {$ENDIF}

  {=== Dessin de rectangles pleins ===}
  repeat
    {$IFDEF SyncroEcran}AttendEcran;{$ENDIF}
    {$IFDEF Vesa}DessineRectanglePlein8{$ELSE}{$IFDEF ModeX}DessineRectanglePleinX{$ELSE}DessineRectanglePlein{$ENDIF}{$ENDIF}
      (Random(LargEcran*2)-LargEcran shr 1,Random(HautEcran*2)-HautEcran shr 1,
       Random(HautEcran shr 1),Random(HautEcran shr 1),Random(256));

   {$IFDEF Fps}ActuFps;{$ENDIF}
  until TouchPresse;
  LitTouche; {$IFDEF Vesa}EffaceEcranVesa{$ELSE}{$IFDEF ModeX}EffaceEcranX{$ELSE}EffaceEcran{$ENDIF}{$ENDIF} (CoulFond);
  {$IFDEF Fps}
    FpsInfo.TxtModifie := TRUE; ActuFps;
    LitTouche;

    FinFps;
  {$ENDIF}

  ModeTxt;
end.